///*|-----------------------------------------------------------------------------
// *|            This source code is provided under the Apache 2.0 license      --
// *|  and is provided AS IS with no warranty or guarantee of fit for purpose.  --
// *|                See the project's LICENSE.md for details.                  --
// *|             Copyright Refinitiv 2021. All rights reserved.                --
///*|-----------------------------------------------------------------------------

#include "Step2.h"

using namespace refinitiv::ema::access;
using namespace refinitiv::ema::rdm;
using namespace std;


void AppClient::onRefreshMsg( const RefreshMsg& refreshMsg, const OmmConsumerEvent& event) {
	cout << "Response message: " << refreshMsg << endl;
	cout << endl << "Waiting for updates. Application will exit in 30 seconds..." << endl;
}


void AppClient::onUpdateMsg( const UpdateMsg& updateMsg, const OmmConsumerEvent& ) {
	cout << "Update message: " << updateMsg << endl;
}



void AppClient::onStatusMsg( const StatusMsg& statusMsg, const OmmConsumerEvent& )	{
	cout << "Status message: " << statusMsg << endl;
}


void AppClient::decode( const FieldList& fl )	{
}



void AppClient::decode( const Map& map )	{
}	



int main( int argc, char* argv[] )	{
	
	try {
		// instantiate callback client
		AppClient client;
		
		cout << "Connecting to market data server" << endl;

		// create OMM consumer
		OmmConsumer consumer( 
			OmmConsumerConfig()
				.host( "ADS:14002" )
				.username( "user" ) 
		);
		
		cout << "Subscribing to market data" << endl;

		// subscribe to Level1 market data
		consumer.registerClient( 
			ReqMsg()
				// default subscription domain is MMT_MARKET_PRICE
				.serviceName( "ELEKTRON_DD" )
				.name( "IBM.N" ),
			client );
		
		// block this thread for a while
		sleep(30000);
		
	} 
	catch ( const OmmException& excp ) {
		cout << "Exception subscribing to market data: " << excp << endl;
	}
	
	return 0;
}
